Lua_GashaponSelectUpHeroWindow = class("Lua_GashaponSelectUpHeroWindow", Lua_Window);
function Lua_GashaponSelectUpHeroWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GashaponSelectUpHeroWindow";
	self.skinName = "GashaponSelectUpHeroWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GashaponSelectUpHeroWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsTxt:setLangValue(765014);

	self.upHeroList = Lua_DragList.new(self.content, 635, 238, Lua_AxisDefine.Vertical);
	self.upHeroList:setListCell(Lua_GashaponSelectUpHeroItem, 127, 112, 5);
	self.upHeroList:setCellSpacing(0, 21);
	self.upHeroList:setLocation(0, 18, 0);

	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
	self.campSiftPanel:setLocation(-32, -154, 0);
	self.campSiftPanel:setSiftItem(73, "595959", 28);
	self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
	self.campSiftPanel:setCallBack(self, self.onCampSelected);
	self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);

	self.cancelBtn:addClickFuntion(self, self.hide);
	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);
	self:addLuaEvent("ON_SELECT_GASHAPON_UPHERO_ITEMCLICK", self, self.recordSelectInfo);
end

function Lua_GashaponSelectUpHeroWindow:onCampSelected(curCampType)
	if self.curCampType == curCampType then
		return;
	end
	self.curCampType = curCampType;

	self:selectUpHeroByCampType();
end

function Lua_GashaponSelectUpHeroWindow:selectUpHeroByCampType()
	local arr = DataCenter.gashaponUtil:getAllUpHeroInfo();
	local info;
	if self.curCampType ~= Lua_HeroUtil.All_TYPE then
		local heroVo;
		local showInfoArr = Array();
		for i = 1, arr:getSize() do
			info = DataCenter.gashaponUtil:getSingleUpHeroInfo(arr[i]);
			heroVo = Lua_ToolVo.createToolVo(info.reward[1]);
			if heroVo.campType == self.curCampType then
				showInfoArr:add(arr[i]);
			end
		end
		arr = showInfoArr;
	end

	local idx;
	local selectInfo = self.recordInfo or DataCenter.gashaponData.selectUpHeroInfo;
	for i = 1, arr:getSize() do
		if selectInfo and arr[i] == selectInfo.id then
			idx = i;
			break;
		end
	end
	self.upHeroList.curSelectedIdx = nil;
	self.upHeroList:setArrayData(arr);
	self.upHeroList:moveToIndex(idx or 1, true);

	if selectInfo and idx then -- 没选择默认不选中
		self.upHeroList:setSelected(idx);
	end
	self:setNoneInfo(arr:getSize() <= 0);
end

function Lua_GashaponSelectUpHeroWindow:setNoneInfo(state)
	if state then
		if self.noneText == nil then
			self.noneText = UICreate.createLabel(self.content, LanUtil.getValue(765005), 0, 95, 0, 30, 40);
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
		end
		self.noneText:setEnable(true);
	else
		if self.noneText ~= nil then
			self.noneText:setEnable(false);
		end
	end
end

function Lua_GashaponSelectUpHeroWindow:recordSelectInfo(recordInfo)
	self.recordInfo = recordInfo;
end

function Lua_GashaponSelectUpHeroWindow:onSureBtnClick(go)
	local selectInfo = self.recordInfo or DataCenter.gashaponData.selectUpHeroInfo;
	if selectInfo == nil then
		OperateAlert.showLangValue(765003);
	else
		Lua_ProxyManager.getProxy("Lua_GashaponProxy"):sChangeGashaponUpHero(selectInfo.id);
		self:hide();
	end
end

function Lua_GashaponSelectUpHeroWindow:dispose()
	if self.upHeroList ~= nil then
		self.upHeroList:dispose();
		self.upHeroList = nil;
	end
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	self:superCall("dispose");
end










Lua_GashaponSelectUpHeroItem = class("Lua_GashaponSelectUpHeroItem", Lua_ListCell);
function Lua_GashaponSelectUpHeroItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GashaponSelectUpHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.upHeroIcon = Lua_ItemIcon.new(self.content);
	self.upHeroIcon:setScale(0.9, 0.9, 0.9);
end

function Lua_GashaponSelectUpHeroItem:setData(data)
	self._data = DataCenter.gashaponUtil:getSingleUpHeroInfo(data);
	if self._data == nil then
		return;
	end

	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(self._data.reward[1]);
	else
		self.tvo:setData(self._data.reward[1]);
	end
	self.upHeroIcon:setData(self.tvo);
end

function Lua_GashaponSelectUpHeroItem:onPressClick()
	Lua_MsgUtil.callFunc("ON_SELECT_GASHAPON_UPHERO_ITEMCLICK", self._data);
	return true;
end

function Lua_GashaponSelectUpHeroItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	self.upHeroIcon:setDrawMask(bSelect);
end

function Lua_GashaponSelectUpHeroItem:dispose()
	if self.upHeroIcon ~= nil then
		self.upHeroIcon:dispose();
		self.upHeroIcon = nil;
	end
	self._data = nil;
	self.tvo = nil;
	self:superCall("dispose");
end